package com.futurescale.sa.controller.command.edit
{
	import com.futurescale.sa.controller.constant.AppConstants;
	import com.futurescale.sa.model.proxy.SeriesProxy;
	import com.futurescale.sa.model.proxy.StoryProxy;
	import com.futurescale.sa.model.vo.SeriesVO;
	import com.futurescale.sa.model.vo.StoryVO;
	import com.futurescale.sa.view.context.SelectionContext;
	import com.futurescale.sa.view.event.AppEvent;
	
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.interfaces.IProxy;
	import org.puremvc.as3.patterns.command.SimpleCommand;
	
	public class DiscardChangesCommand extends SimpleCommand
	{
		override public function execute( note:INotification ):void
		{
			// Get the event from 
			var event:AppEvent = AppEvent( note.getBody() );
			
			// Get the SelectionContext
			var scProxy:IProxy = facade.retrieveProxy( SelectionContext.NAME );
			var context:SelectionContext = SelectionContext( scProxy.getData() );
			
			// Proxys we may need
			var storyProxy:StoryProxy;
			var seriesProxy:SeriesProxy;

			// Remove entity from selection context and re-cache from disk
			switch ( event.type ) 
			{
				case AppEvent.DISCARD_STORY:
					storyProxy = StoryProxy( facade.retrieveProxy( StoryProxy.NAME ) );
					var story:StoryVO = context.story;
					storyProxy.loadStory( story, true );
					context.selectStory( null );
					break;
				
				case AppEvent.DISCARD_SERIES:
					var series:SeriesVO = context.series;
					seriesProxy = SeriesProxy( facade.retrieveProxy( SeriesProxy.NAME ) );
					seriesProxy.loadSeries( series, true );
					context.selectSeries( null );
					break;
			}
			
			// Send the user back to the chooser
			sendNotification( AppConstants.SHOW_CHOOSER );
		}
	}
}