package com.futurescale.sa.controller.command.series
{
	import com.futurescale.sa.controller.constant.AppConstants;
	import com.futurescale.sa.model.proxy.SeriesProxy;
	import com.futurescale.sa.model.proxy.StoryProxy;
	import com.futurescale.sa.model.vo.SeriesVO;
	import com.futurescale.sa.view.context.SelectionContext;
	
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.interfaces.IProxy;
	import org.puremvc.as3.patterns.command.SimpleCommand;
	
	/**
	 * Prepare a series for editing.
	 */
	public class EditSeriesCommand extends SimpleCommand
	{
		override public function execute( note:INotification ):void
		{
			// Get the series from the note body.			
			var series:SeriesVO = SeriesVO( note.getBody() );
			
			// Get the SelectionContext
			var scProxy:IProxy = facade.retrieveProxy( SelectionContext.NAME );
			var context:SelectionContext = SelectionContext( scProxy.getData() );

			// Be sure we have the full Series, not the stub from the Chooser list
			if ( series.isStub ) {
				var seriesProxy:SeriesProxy = SeriesProxy( facade.retrieveProxy( SeriesProxy.NAME ) );
				series = seriesProxy.loadSeries( series );
			}
			
			// Select the series 			
			context.selectSeries( series );
			
			// Tell the View to edit the series. 
			sendNotification( AppConstants.SHOW_EDITOR );
		}
	}
}