package com.futurescale.sa.controller.command.test
{
	import com.futurescale.sa.model.proxy.SeriesProxy;
	import com.futurescale.sa.model.vo.ChapterVO;
	import com.futurescale.sa.model.vo.SeasonVO;
	import com.futurescale.sa.model.vo.SeriesVO;
	import com.futurescale.sa.model.vo.StoryVO;
	
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.command.SimpleCommand;
	
	public class MockupLostDataCommand extends SimpleCommand
	{
		override public function execute( note:INotification ):void
		{
			// Create a Series
			var series:SeriesVO = new SeriesVO();
			series.name = "Lost";

			var season1:SeasonVO = series.getNewSeason();
			var season2:SeasonVO = series.getNewSeason();
			var season3:SeasonVO = series.getNewSeason();
			var season4:SeasonVO = series.getNewSeason();
			var season5:SeasonVO = series.getNewSeason();
			var season6:SeasonVO = series.getNewSeason();

			// Season 1
			var episode01:StoryVO = generateEpisode( series, season1, "Pilot, Part 1");
			var episode02:StoryVO = generateEpisode( series, season1, "Pilot, Part 2");
			var episode03:StoryVO = generateEpisode( series, season1, "Tabula Rasa");
			var episode04:StoryVO = generateEpisode( series, season1, "Walkabout");
			var episode05:StoryVO = generateEpisode( series, season1, "White Rabbit");
			var episode06:StoryVO = generateEpisode( series, season1, "House of the Rising Sun");
			var episode07:StoryVO = generateEpisode( series, season1, "The Moth");
			var episode08:StoryVO = generateEpisode( series, season1, "Tabula Rasa");
			var episode09:StoryVO = generateEpisode( series, season1, "Confidence Man");
			var episode10:StoryVO = generateEpisode( series, season1, "Solitary");
			var episode11:StoryVO = generateEpisode( series, season1, "Raised by Another");
			var episode12:StoryVO = generateEpisode( series, season1, "All the Best Cowboys Have Daddy Issues");
			var episode13:StoryVO = generateEpisode( series, season1, "Whatever the Case May Be");
			var episode14:StoryVO = generateEpisode( series, season1, "Hearts and Minds");
			var episode15:StoryVO = generateEpisode( series, season1, "Special");
			var episode16:StoryVO = generateEpisode( series, season1, "...In Translation");
			var episode17:StoryVO = generateEpisode( series, season1, "Homecoming");
			var episode18:StoryVO = generateEpisode( series, season1, "Numbers");
			var episode19:StoryVO = generateEpisode( series, season1, "Deus Ex Machina");
			var episode20:StoryVO = generateEpisode( series, season1, "Do No Harm");
			var episode21:StoryVO = generateEpisode( series, season1, "Exodus, Part 1");
			var episode22:StoryVO = generateEpisode( series, season1, "Exodus, Part 2");

			// save fake data
			var seriesProxy:SeriesProxy = SeriesProxy( facade.retrieveProxy(SeriesProxy.NAME) );
			seriesProxy.addSeries(series);
		}
		
		private function generateEpisode( series:SeriesVO, season:SeasonVO, name:String ):StoryVO
		{
			var episode:StoryVO = series.getNewStory( season );
			episode.useScenes = true;
			episode.name = name;
			return episode;
		}
	}
}