package com.futurescale.sa.model.enum
{
	import mx.collections.ArrayCollection;

	/**
	 * An enumeration of developmental levels in the Enneagram system.
	 */
	[Bindable] public class EgramCenterEnum extends Enum
	{
		public static const HELP:String = "http://www.enneagraminstitute.com/intro.asp#centers";
		
		public static const NONE:EgramCenterEnum  		= new EgramCenterEnum( -1, "--None Selected--", "Choose an Enneagram Center");
		public static const THINKING:EgramCenterEnum 	= new EgramCenterEnum( 0,  "Thinking", 			"Anxiety / Dread" );
		public static const INSTINCT:EgramCenterEnum  	= new EgramCenterEnum( 1,  "Instinct", 			"Anger / Rage" );
		public static const FEELING:EgramCenterEnum  	= new EgramCenterEnum( 2,  "Feeling",  			"Shame" );

		public function EgramCenterEnum( ordinal:Number, name:String, dominantEmotion:String )
		{
			super ( ordinal, name, dominantEmotion );
		}
	
		public static function get list():Array
		{
			return [ THINKING, INSTINCT, FEELING ];
		}
		
		public static function get comboList():ArrayCollection
		{
			return new ArrayCollection([ NONE ].concat( list ));
		}
		
		override public function equals( enum:Enum ):Boolean
		{
			return ( enum is EgramCenterEnum && super.equals( enum ) );
		}
	}
}