package com.futurescale.sa.controller.command.edit
{
	import com.futurescale.sa.controller.constant.AppConstants;
	import com.futurescale.sa.model.proxy.SeriesProxy;
	import com.futurescale.sa.model.proxy.StoryProxy;
	import com.futurescale.sa.model.vo.SeriesVO;
	import com.futurescale.sa.model.vo.StoryVO;
	import com.futurescale.sa.view.event.AppEvent;
	
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.command.SimpleCommand;
	
	public class ApplyChangesCommand extends SimpleCommand
	{
		override public function execute( note:INotification ):void
		{
			// Get the event from the note body
			var event:AppEvent = AppEvent( note.getBody() );
			
			// Proxys we may need
			var storyProxy:StoryProxy;
			var seriesProxy:SeriesProxy;

			// Save entity to disk
			switch ( event.type ) 
			{
				case AppEvent.SAVE_STORY:
					storyProxy = StoryProxy( facade.retrieveProxy( StoryProxy.NAME ) );
					var story:StoryVO = StoryVO( event.data );
					storyProxy.saveStory( story );
					break;
				
				case AppEvent.SAVE_SERIES:
					seriesProxy = SeriesProxy( facade.retrieveProxy( SeriesProxy.NAME ) );
					var series:SeriesVO = SeriesVO( event.data );
					seriesProxy.saveSeries( series );
					break;
				
			}
			
			// Send the user back to the chooser
			sendNotification( AppConstants.SHOW_CHOOSER );
		}
	}
}