package com.futurescale.sa.controller.command.startup
{
	import com.futurescale.sa.controller.command.edit.AddItemCommand;
	import com.futurescale.sa.controller.command.edit.ApplyChangesCommand;
	import com.futurescale.sa.controller.command.edit.ApplySelectionCommand;
	import com.futurescale.sa.controller.command.edit.DeleteItemCommand;
	import com.futurescale.sa.controller.command.edit.DiscardChangesCommand;
	import com.futurescale.sa.controller.command.edit.MoveItemCommand;
	import com.futurescale.sa.controller.command.edit.RemoveSelectionCommand;
	import com.futurescale.sa.controller.command.series.EditSeriesCommand;
	import com.futurescale.sa.controller.command.series.ManageSeriesCommand;
	import com.futurescale.sa.controller.command.shutdown.ExitAppCommand;
	import com.futurescale.sa.controller.command.story.EditStoryCommand;
	import com.futurescale.sa.controller.command.story.ManageStoryCommand;
	import com.futurescale.sa.controller.constant.AppConstants;
	import com.futurescale.sa.model.proxy.SeriesProxy;
	import com.futurescale.sa.model.proxy.StoryProxy;
	
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.command.SimpleCommand;
	
	/** 
	 * Prepare the Controller.
	 * 
	 * Register all Commands other than StartupCommand
	 */
	public class PrepareControllerCommand extends SimpleCommand
	{
		override public function execute( note:INotification ):void
		{
			// Initiated by the App
			facade.registerCommand( AppConstants.EXIT_APP, 			ExitAppCommand );

			// Initiated by the Chooser
			facade.registerCommand( AppConstants.MANAGE_STORY, 		ManageStoryCommand );
			facade.registerCommand( AppConstants.MANAGE_SERIES, 	ManageSeriesCommand );
			facade.registerCommand( AppConstants.EDIT_STORY, 		EditStoryCommand );
			facade.registerCommand( StoryProxy.STORY_ADDED, 		EditStoryCommand );
			facade.registerCommand( AppConstants.EDIT_SERIES, 		EditSeriesCommand );
			facade.registerCommand( SeriesProxy.SERIES_ADDED, 		EditSeriesCommand );
			
			// Initiated by the Editor			
			facade.registerCommand( AppConstants.ADD_ITEM, 			AddItemCommand );
			facade.registerCommand( AppConstants.DELETE_ITEM, 		DeleteItemCommand );
			facade.registerCommand( AppConstants.MOVE_ITEM, 		MoveItemCommand );
			facade.registerCommand( AppConstants.APPLY_SELECTION, 	ApplySelectionCommand );
			facade.registerCommand( AppConstants.REMOVE_SELECTION,  RemoveSelectionCommand );
			facade.registerCommand( AppConstants.DISCARD_CHANGES, 	DiscardChangesCommand );
			facade.registerCommand( AppConstants.APPLY_CHANGES, 	ApplyChangesCommand );
		}
	}
}