package com.futurescale.sa.controller.command.startup
{
	import com.futurescale.sa.model.proxy.CastProxy;
	import com.futurescale.sa.model.proxy.MilieuProxy;
	import com.futurescale.sa.model.proxy.SeriesProxy;
	import com.futurescale.sa.model.proxy.StoryProxy;
	
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.command.SimpleCommand;
	
	/** 
	 * Prepare the Model.
	 */
	public class PrepareModelCommand extends SimpleCommand
	{
		override public function execute( note:INotification ):void
		{
			// Create and register the Proxys for the domain model.
			var castProxy:CastProxy 	= new CastProxy();
			var milieuProxy:MilieuProxy = new MilieuProxy();
			var storyProxy:StoryProxy 	= new StoryProxy( milieuProxy, castProxy );
			var seriesProxy:SeriesProxy = new SeriesProxy( storyProxy, milieuProxy, castProxy);
			
			facade.registerProxy( castProxy );
			facade.registerProxy( milieuProxy );
			facade.registerProxy( storyProxy );
			facade.registerProxy( seriesProxy );
		}
	}
}