package com.futurescale.sa.model.enum
{
	import mx.collections.ArrayCollection;

	/**
	 * An enumeration of developmental levels in the Enneagram system.
	 */
	[Bindable] public class EgramLevelEnum extends Enum
	{
		public static const HELP:String = "http://www.enneagraminstitute.com/intro.asp#levels";
		
		public static const NONE:EgramLevelEnum  	= new EgramLevelEnum( -1, "--None Selected--", "", 	"Choose an Enneagram Level");
		public static const LEVEL_1:EgramLevelEnum	= new EgramLevelEnum(  0, "Level 1", HEALTHY,   	"Liberation" );
		public static const LEVEL_2:EgramLevelEnum	= new EgramLevelEnum(  1, "Level 2", HEALTHY,   	"Psychological Capacity" );
		public static const LEVEL_3:EgramLevelEnum	= new EgramLevelEnum(  2, "Level 3", HEALTHY,   	"Social Value" );
		public static const LEVEL_4:EgramLevelEnum	= new EgramLevelEnum(  3, "Level 4", AVERAGE,   	"Imbalance / Social Role" );
		public static const LEVEL_5:EgramLevelEnum	= new EgramLevelEnum(  4, "Level 5", AVERAGE,   	"Interpersonal Control" );
		public static const LEVEL_6:EgramLevelEnum	= new EgramLevelEnum(  5, "Level 6", AVERAGE,   	"Overcompensation" );
		public static const LEVEL_7:EgramLevelEnum	= new EgramLevelEnum(  6, "Level 7", UNHEALTHY, 	"Violation" );
		public static const LEVEL_8:EgramLevelEnum	= new EgramLevelEnum(  7, "Level 8", UNHEALTHY, 	"Obsession and Compulsion" );
		public static const LEVEL_9:EgramLevelEnum	= new EgramLevelEnum(  8, "Level 9", UNHEALTHY, 	"Pathological Destructiveness" );

		private static const HEALTHY:String 	= "Healthy";
		private static const AVERAGE:String 	= "Average";
		private static const UNHEALTHY:String 	= "Unhealthy";

		public var range:String;

		public function EgramLevelEnum( ordinal:Number, name:String, range:String, description:String )
		{
			super ( ordinal, name, description );
			this.range = range;
		}
		
		public static function get list():Array
		{
			return [ LEVEL_1, LEVEL_2, LEVEL_3, LEVEL_4, LEVEL_5, LEVEL_6, LEVEL_7, LEVEL_8, LEVEL_9 ];
		}
		
		public static function get comboList():ArrayCollection
		{
			return new ArrayCollection([ NONE ].concat( list ));
		}
		
		override public function equals( enum:Enum ):Boolean
		{
			return ( enum is EgramLevelEnum && super.equals( enum ) );
		}
	}
}