package com.futurescale.sa.model.enum
{
	import mx.collections.ArrayCollection;

	/**
	 * An enumeration of personality types in the Enneagram system
	 */
	[Bindable] public class EgramTypeEnum extends Enum
	{
		public static const HELP:String = "http://www.enneagraminstitute.com/intro.asp#type";

		public static const NONE:EgramTypeEnum  	= new EgramTypeEnum( -1, "--None Selected--", 	 EgramCenterEnum.NONE,		"Choose an Enneagram Type");
		public static const TYPE_1:EgramTypeEnum	= new EgramTypeEnum(  0, "1 - The Reformer", 	 EgramCenterEnum.INSTINCT,	"Principled, purposeful, self-controlled, and perfectionistic." );
		public static const TYPE_2:EgramTypeEnum	= new EgramTypeEnum(  1, "2 - The Helper",		 EgramCenterEnum.FEELING,	"Demonstrative, generous, people-pleasing, and possessive." );
		public static const TYPE_3:EgramTypeEnum	= new EgramTypeEnum(  2, "3 - The Achiever", 	 EgramCenterEnum.FEELING,	"Adaptive, excelling, driven, and image-conscious." );
		public static const TYPE_4:EgramTypeEnum	= new EgramTypeEnum(  3, "4 - The Individualist",EgramCenterEnum.FEELING,	"Expressive, dramatic, self-absorbed, and temperamental." );
		public static const TYPE_5:EgramTypeEnum	= new EgramTypeEnum(  4, "5 - The Investigator", EgramCenterEnum.THINKING,	"Perceptive, innovative, secretive, and isolated." );
		public static const TYPE_6:EgramTypeEnum	= new EgramTypeEnum(  5, "6 - The Loyalist", 	 EgramCenterEnum.THINKING,	"Engaging, responsible, anxious, and suspicious." );
		public static const TYPE_7:EgramTypeEnum	= new EgramTypeEnum(  6, "7 - The Enthusiast", 	 EgramCenterEnum.THINKING,	"Spontaneous, versatile, distractible, and scattered." );
		public static const TYPE_8:EgramTypeEnum	= new EgramTypeEnum(  7, "8 - The Challenger", 	 EgramCenterEnum.INSTINCT,	"Self-confident, decisive, willful, and confrontational." );
		public static const TYPE_9:EgramTypeEnum	= new EgramTypeEnum(  8, "9 - The Peacemaker", 	 EgramCenterEnum.INSTINCT,	"Receptive, reassuring, agreeable, and complacent." );
		
		public var center:EgramCenterEnum;
		
		public function EgramTypeEnum( ordinal:Number, name:String, center:EgramCenterEnum, description:String )
		{
			super ( ordinal, name, description );
			this.center = center;
		}

		public static function get list():Array
		{
			return [ TYPE_1, TYPE_2, TYPE_3, TYPE_4, TYPE_5, TYPE_6, TYPE_7, TYPE_8, TYPE_9 ];
		}
		
		public static function get comboList():ArrayCollection
		{
			return new ArrayCollection([ NONE ].concat( list ));
		}
		
		override public function equals( enum:Enum ):Boolean
		{
			return ( enum is EgramTypeEnum && super.equals( enum ) );
		}
	}
}