package com.futurescale.sa.model.enum
{
	import mx.collections.ArrayCollection;

	/**
	 * An enumeration of Viewpoints for a Scene. 
	 * 
	 * Viewpoints are ordered by likelyhood of use.
	 */
	[Bindable] public class ViewpointEnum extends Enum
	{
		public static const NONE:ViewpointEnum  		= new ViewpointEnum( -1, "None Selected", 				"Choose a Viewpoint" 			);
		public static const THIRD_LIMITED:ViewpointEnum = new ViewpointEnum( 0,  "Third Person - Limited", 		"Luke sees, Luke saw" 			);
		public static const THIRD_OMNI:ViewpointEnum 	= new ViewpointEnum( 1,  "Third Person - Omniescent", 	"She goes, they go, they went" 	);
		public static const FIRST:ViewpointEnum 		= new ViewpointEnum( 2,  "First Person", 				"I go, we go, we went" 			);
		public static const SECOND:ViewpointEnum 		= new ViewpointEnum( 3,  "Second Person", 				"You go, you went" 				);
		
		public function ViewpointEnum( ordinal:Number, name:String, description:String )
		{
			super( ordinal, name, description );
		}
		
		public static function get list():Array
		{
			return [ THIRD_LIMITED, THIRD_OMNI, FIRST, SECOND ];
		}
		
		public static function get comboList():ArrayCollection
		{
			return new ArrayCollection([ NONE ].concat( list ));
		}
		
		override public function equals( enum:Enum ):Boolean
		{
			return ( enum is ViewpointEnum && super.equals( enum ) );
		}
	}
}