package com.futurescale.sa.model.vo
{
	/**
	 * A Note is freeform text, url or image associated with another
	 * entity 
	 */
	[Bindable] public class NoteVO
	{
		/**
		 * The XML element name.
		 */
		public static const ELEMENT:String = "Note";
		
		/**
		 * Construct a NoteVO.
		 */
		public function NoteVO( xml:XML=null )
		{
			this.xml = (xml)?xml:<{ELEMENT}/>;
		}

		/**
		 * The text of this Note.
		 */
		public function get text():String
		{
			return xml.toString();
		}
		public function set text( t:String ):void
		{
			x.setChildren(t);
		}

		/**
		 * An optional URL.
		 */
		public function get url():String
		{
			return xml.@url;
		}
		public function set url( u:String ):void
		{
			xml.@url = u;	
		}
		
		/**
		 * XML representation of the Note.
		 */
		public function get xml():XML
		{
			return x;	
		}
		public function set xml( x:XML ):void
		{
			this.x = x;
		}
		protected var x:XML;
		
		public function equals( vo:NoteVO ):Boolean
		{
			return ( url == vo.url &&
					 text == vo.text );
		}

	}
}