package com.futurescale.sa.model.enum.test
{
	import com.futurescale.sa.model.enum.EgramCenterEnum;
	import com.futurescale.sa.model.enum.Enum;
	
	import flexunit.framework.Assert;
	
	import mx.collections.ArrayCollection;
	
	public class EgramCenterEnumTest
	{		
		[Test]
		public function testEgramCenterEnum():void
		{
			var ord:Number = 6;
			var name:String = "Testing";
			var emotion:String = "Nervy";
			
			var enum:EgramCenterEnum = new EgramCenterEnum( ord, name, emotion );
			
			if ( !enum is Enum ) 					Assert.fail("Does not extend Enum");
			if ( !enum is EgramCenterEnum ) 		Assert.fail("Not an instance of EgramCenterEnum");
			if ( enum.ordinal		!= ord ) 		Assert.fail("Ordinal match failed");
			if ( enum.name 			!= name ) 		Assert.fail("Name match failed");
			if ( enum.description 	!= emotion )	Assert.fail("Description match failed");
		}
		
		[Test]
		public function testGet_list():void
		{
			var list:Array = EgramCenterEnum.list;
			if ( !list ) 			Assert.fail("List not returned");
			if ( !list.length > 0 ) Assert.fail("Zero length list");
			if ( !EgramCenterEnum( list[0] ).equals( EgramCenterEnum.THINKING ) ) 	Assert.fail("[0] not THINKING");
			if ( !EgramCenterEnum( list[1] ).equals( EgramCenterEnum.INSTINCT ) ) 	Assert.fail("[1] not INSTINCT");
			if ( !EgramCenterEnum( list[2] ).equals( EgramCenterEnum.FEELING ) ) 	Assert.fail("[2] not FEELING");
		}

		[Test]
		public function testGet_comboList():void
		{
			var comboList:ArrayCollection = EgramCenterEnum.comboList;
			if ( !comboList ) 	Assert.fail("List not returned");
			if ( !(comboList.length == EgramCenterEnum.list.length + 1 )  ) 					Assert.fail("Wrong list length");
			if ( !EgramCenterEnum( comboList.getItemAt(0) ).equals( EgramCenterEnum.NONE ) ) 	Assert.fail("[0] not NONE");
			if ( !EgramCenterEnum( comboList.getItemAt(1) ).equals( EgramCenterEnum.list[0] ) ) Assert.fail("comboList[1] not list[0]");
		}
	}
}