package com.futurescale.sa.model.enum.test
{
	import com.futurescale.sa.model.enum.EgramLevelEnum;
	import com.futurescale.sa.model.enum.Enum;
	
	import flexunit.framework.Assert;
	
	import mx.collections.ArrayCollection;
	
	public class EgramLevelEnumTest
	{		
		[Test]
		public function testEgramLevelEnum():void
		{
			var ord:Number = 6;
			var name:String 	= "Testing";
			var range:String 	= "Fairly Odd";
			var desc:String 	= "Above average oddness";
			
			var enum:EgramLevelEnum = new EgramLevelEnum( ord, name, range, desc );
			
			if ( !enum is Enum ) 					Assert.fail("Does not extend Enum");
			if ( !enum is EgramLevelEnum ) 			Assert.fail("Not an instance of EgramLevelEnum");
			if ( enum.ordinal		!= ord ) 		Assert.fail("Ordinal match failed");
			if ( enum.name 			!= name ) 		Assert.fail("Name match failed");
			if ( enum.description 	!= desc )		Assert.fail("Description match failed");
			if ( enum.range			!= range )		Assert.fail("Range match failed");
		}
		
		[Test]
		public function testGet_list():void
		{
			var list:Array = EgramLevelEnum.list;
			if ( !list ) 			Assert.fail("List not returned");
			if ( !list.length > 0 ) Assert.fail("Zero length list");
			if ( !EgramLevelEnum( list[0] ).equals( EgramLevelEnum.LEVEL_1 ) ) 	Assert.fail("[0] not LEVEL_1");
			if ( !EgramLevelEnum( list[1] ).equals( EgramLevelEnum.LEVEL_2 ) ) 	Assert.fail("[1] not LEVEL_2");
			if ( !EgramLevelEnum( list[2] ).equals( EgramLevelEnum.LEVEL_3 ) ) 	Assert.fail("[2] not LEVEL_3");
			if ( !EgramLevelEnum( list[3] ).equals( EgramLevelEnum.LEVEL_4 ) ) 	Assert.fail("[3] not LEVEL_4");
			if ( !EgramLevelEnum( list[4] ).equals( EgramLevelEnum.LEVEL_5 ) ) 	Assert.fail("[4] not LEVEL_5");
			if ( !EgramLevelEnum( list[5] ).equals( EgramLevelEnum.LEVEL_6 ) ) 	Assert.fail("[5] not LEVEL_6");
			if ( !EgramLevelEnum( list[6] ).equals( EgramLevelEnum.LEVEL_7 ) ) 	Assert.fail("[6] not LEVEL_7");
			if ( !EgramLevelEnum( list[7] ).equals( EgramLevelEnum.LEVEL_8 ) ) 	Assert.fail("[7] not LEVEL_8");
		}

		[Test]
		public function testGet_comboList():void
		{
			var comboList:ArrayCollection = EgramLevelEnum.comboList;
			if ( !comboList ) 	Assert.fail("List not returned");
			if ( !(comboList.length == EgramLevelEnum.list.length + 1 )  ) 					Assert.fail("Wrong list length");
			if ( !EgramLevelEnum( comboList.getItemAt(0) ).equals( EgramLevelEnum.NONE ) ) 	Assert.fail("[0] not NONE");
			if ( !EgramLevelEnum( comboList.getItemAt(1) ).equals( EgramLevelEnum.list[0] ) ) Assert.fail("comboList[1] not list[0]");
		}
		
	}
}