package com.futurescale.sa.model.enum.test
{
	import com.futurescale.sa.model.enum.EgramCenterEnum;
	import com.futurescale.sa.model.enum.EgramTypeEnum;
	import com.futurescale.sa.model.enum.Enum;
	
	import flexunit.framework.Assert;
	
	import mx.collections.ArrayCollection;
	
	public class EgramTypeEnumTest
	{		
		[Test]
		public function testEgramTypeEnum():void
		{
			var ord:Number = 19;
			var name:String = "Testing";
			var desc:String = "That basketball was like a, like a basketball to me! I gotta basketball jones.";
			
			var enum:EgramTypeEnum = new EgramTypeEnum( ord, name, EgramCenterEnum.FEELING, desc );
			
			if ( !enum is Enum ) 									Assert.fail("Does not extend Enum");
			if ( !enum is EgramTypeEnum ) 							Assert.fail("Not an instance of EgramTypeEnum");
			if ( enum.ordinal		!= ord ) 						Assert.fail("Ordinal match failed");
			if ( enum.name 			!= name ) 						Assert.fail("Name match failed");
			if ( enum.description 	!= desc )						Assert.fail("Description match failed");
			if ( enum.center		!= EgramCenterEnum.FEELING )	Assert.fail("Center match failed");
		}
		
		[Test]
		public function testGet_list():void
		{
			var list:Array = EgramTypeEnum.list;
			if ( !list ) 			Assert.fail("List not returned");
			if ( !list.length > 0 ) Assert.fail("Zero length list");
			if ( !EgramTypeEnum( list[0] ).equals( EgramTypeEnum.TYPE_1 ) ) Assert.fail("[0] not TYPE_1");
			if ( !EgramTypeEnum( list[1] ).equals( EgramTypeEnum.TYPE_2 ) ) Assert.fail("[1] not TYPE_2");
			if ( !EgramTypeEnum( list[2] ).equals( EgramTypeEnum.TYPE_3 ) ) Assert.fail("[2] not TYPE_3");
			if ( !EgramTypeEnum( list[3] ).equals( EgramTypeEnum.TYPE_4 ) ) Assert.fail("[3] not TYPE_4");
			if ( !EgramTypeEnum( list[4] ).equals( EgramTypeEnum.TYPE_5 ) ) Assert.fail("[4] not TYPE_5");
			if ( !EgramTypeEnum( list[5] ).equals( EgramTypeEnum.TYPE_6 ) ) Assert.fail("[5] not TYPE_6");
			if ( !EgramTypeEnum( list[6] ).equals( EgramTypeEnum.TYPE_7 ) ) Assert.fail("[6] not TYPE_7");
			if ( !EgramTypeEnum( list[7] ).equals( EgramTypeEnum.TYPE_8 ) ) Assert.fail("[7] not TYPE_8");
			if ( !EgramTypeEnum( list[8] ).equals( EgramTypeEnum.TYPE_9 ) ) Assert.fail("[8] not TYPE_9");
		}

		[Test]
		public function testGet_comboList():void
		{
			var comboList:ArrayCollection = EgramTypeEnum.comboList;
			if ( !comboList ) Assert.fail("List not returned");
			if ( !(comboList.length == EgramTypeEnum.list.length + 1 )  ) 			Assert.fail("Wrong list length");
			if ( !EgramTypeEnum( comboList.getItemAt(0) ).equals( EgramTypeEnum.NONE ) ) 		Assert.fail("[0] not NONE");
			if ( !EgramTypeEnum( comboList.getItemAt(1) ).equals( EgramTypeEnum.list[0] ) ) 	Assert.fail("comboList[1] not list[0]");
		}
		
	}
}