package com.futurescale.sa.model.enum.test
{
	import com.futurescale.sa.model.enum.Enum;
	import com.futurescale.sa.model.enum.StoryTypeEnum;
	
	import flexunit.framework.Assert;
	
	import mx.collections.ArrayCollection;
	
	public class StoryTypeEnumTest
	{		
		[Test]
		public function testStoryTypeEnum():void
		{
			var ord:Number = 3;
			var name:String = "Apostroparenthetical";
			var desc:String = "A story that has only punctuation.";
			
			var enum:StoryTypeEnum = new StoryTypeEnum( ord, name, desc );
			
			if ( !enum is Enum ) 				Assert.fail("Does not extend Enum");
			if ( !enum is StoryTypeEnum ) 		Assert.fail("Not an instance of StoryTypeEnum");
			if ( enum.ordinal		!= ord ) 	Assert.fail("Ordinal match failed");
			if ( enum.name 			!= name ) 	Assert.fail("Name match failed");
			if ( enum.description 	!= desc )	Assert.fail("Description match failed");
		}

		[Test]
		public function testGet_list():void
		{
			var list:Array = StoryTypeEnum.list;
			if ( !list ) 			Assert.fail("List not returned");
			if ( !list.length > 0 ) Assert.fail("Zero length list");
			if ( !StoryTypeEnum( list[0] ).equals( StoryTypeEnum.SIMPLE ) )  Assert.fail("[0] not SIMPLE");
			if ( !StoryTypeEnum( list[1] ).equals( StoryTypeEnum.NORMAL ) )  Assert.fail("[1] not NORMAL");
			if ( !StoryTypeEnum( list[2] ).equals( StoryTypeEnum.COMPLEX ) ) Assert.fail("[2] not COMPLEX");
		}
		
		[Test]
		public function testGet_comboList():void
		{
			var comboList:ArrayCollection = StoryTypeEnum.comboList;
			if ( !comboList ) Assert.fail("List not returned");
			if ( !(comboList.length == StoryTypeEnum.list.length + 1 )  ) 					Assert.fail("Wrong list length");
			if ( !StoryTypeEnum( comboList.getItemAt(0) ).equals( StoryTypeEnum.NONE ) ) 	Assert.fail("[0] not NONE");
			if ( !StoryTypeEnum( comboList.getItemAt(1) ).equals( StoryTypeEnum.list[0] ) ) Assert.fail("comboList[1] not list[0]");
		}
	}
}