package com.futurescale.sa.model.enum.test
{
	import com.futurescale.sa.model.enum.Enum;
	import com.futurescale.sa.model.enum.ViewpointEnum;
	
	import flexunit.framework.Assert;
	
	import mx.collections.ArrayCollection;
	
	public class ViewpointEnumTest
	{		
		[Test]
		public function testViewpointEnum():void
		{
			var ord:Number = 3;
			var name:String = "Fly on Wall";
			var desc:String = "Narrated from perspective of an actual fly. Has a very darty and random quality to it.";
			
			var enum:ViewpointEnum = new ViewpointEnum( ord, name, desc );
			
			if ( !enum is Enum ) 				Assert.fail("Does not extend Enum");
			if ( !enum is ViewpointEnum ) 		Assert.fail("Not an instance of ViewpointEnum");
			if ( enum.ordinal		!= ord ) 	Assert.fail("Ordinal match failed");
			if ( enum.name 			!= name ) 	Assert.fail("Name match failed");
			if ( enum.description 	!= desc )	Assert.fail("Description match failed");
		}
		
		[Test]
		public function testGet_list():void
		{
			var list:Array = ViewpointEnum.list;
			if ( !list ) 			Assert.fail("List not returned");
			if ( !list.length > 0 ) Assert.fail("Zero length list");
			if ( !ViewpointEnum( list[0] ).equals( ViewpointEnum.THIRD_LIMITED ) )  Assert.fail("[0] not THIRD_LIMITED");
			if ( !ViewpointEnum( list[1] ).equals( ViewpointEnum.THIRD_OMNI ) )  	Assert.fail("[1] not THIRD_OMNI");
			if ( !ViewpointEnum( list[2] ).equals( ViewpointEnum.FIRST ) ) 			Assert.fail("[2] not FIRST");
			if ( !ViewpointEnum( list[3] ).equals( ViewpointEnum.SECOND ) ) 		Assert.fail("[3] not SECOND");
		}
		
		[Test]
		public function testGet_comboList():void
		{
			var comboList:ArrayCollection = ViewpointEnum.comboList;
			if ( !comboList ) Assert.fail("List not returned");
			if ( !(comboList.length == ViewpointEnum.list.length + 1 )  ) 					Assert.fail("Wrong list length");
			if ( !ViewpointEnum( comboList.getItemAt(0) ).equals( ViewpointEnum.NONE ) ) 	Assert.fail("[0] not NONE");
			if ( !ViewpointEnum( comboList.getItemAt(1) ).equals( ViewpointEnum.list[0] ) ) Assert.fail("comboList[1] not list[0]");
		}
	}
}