package com.futurescale.sa.model.vo.test
{
	import com.futurescale.sa.model.vo.DraftVO;
	
	import flexunit.framework.Assert;
	
	public class DraftVOTest
	{		
		[Test]
		public function testDraftVOWithoutXML():void
		{
			var vo:DraftVO = new DraftVO();
			if ( ! vo is DraftVO ) Assert.fail("construction failed");
			if ( ! vo.xml is XML )  						Assert.fail("default xml not provided");
			if ( vo.isCurrent != false ) 					Assert.fail("isCurrent match failed");
			if ( vo.xml.localName() != DraftVO.ELEMENT )	Assert.fail("improper xml default");
		}
		
		[Test]
		public function testDraftVOWithXML():void
		{
			var text:String = "It was a dark and stormy night...";
			var uid:String = "ou812"
			var xml:XML = <Draft uid={uid} isCurrent="true">{text}</Draft>;
			var vo:DraftVO = new DraftVO(xml);
			if ( ! vo is DraftVO ) 		Assert.fail("construction failed");
			if ( vo.uid != uid ) 		Assert.fail("uid match failed");
			if ( vo.isCurrent != true ) Assert.fail("isCurrent match failed");
			if ( vo.text != text )		Assert.fail("text match failed");
		}
		
		[Test]
		public function testSet_text():void
		{
			var text:String = "It was a dark and stormy night...";
			var vo:DraftVO = new DraftVO();
			vo.text = text;
			if ( vo.text != text )		Assert.fail("text match failed");
		}
		
		[Test]
		public function testClone():void
		{
			var text:String = "It was a dark and stormy night...";
			var uid:String = "ou812"
			var xml:XML = <draft uid={uid} isCurrent="true">{text}</draft>;
			var vo1:DraftVO = new DraftVO();
			var vo2:DraftVO = vo1.clone();
			if ( vo1.uid != vo2.uid )				Assert.fail("uid match failed");
			if ( vo1.text != vo2.text )				Assert.fail("text match failed");
			if ( vo1.isCurrent!= vo2.isCurrent )	Assert.fail("isCurrent match failed");
			if ( vo1.isCurrent!= vo2.isCurrent )	Assert.fail("isCurrent match failed");
		}
		
	}
}